package org.dromara.zhishu.service;

import org.dromara.zhishu.domain.vo.FilterSetVo;
import org.dromara.zhishu.domain.bo.FilterSetBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 过滤设置Service接口
 *
 * @author yxy
 * @date 2025-04-14
 */
public interface IFilterSetService {

    /**
     * 查询过滤设置
     *
     * @param id 主键
     * @return 过滤设置
     */
    FilterSetVo queryById(Long id);

    /**
     * 分页查询过滤设置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 过滤设置分页列表
     */
    TableDataInfo<FilterSetVo> queryPageList(FilterSetBo bo, PageQuery pageQuery);

    /**
     * 查询过滤库
     * @return
     */
    List<FilterSetVo> selectVoListByBo(FilterSetBo bo);

    int deleteTrueById(Long id);

    /**
     * 查询符合条件的过滤设置列表
     *
     * @param bo 查询条件
     * @return 过滤设置列表
     */
    List<FilterSetVo> queryList(FilterSetBo bo);

    /**
     * 新增过滤设置
     *
     * @param bo 过滤设置
     * @return 是否新增成功
     */
    Boolean insertByBo(FilterSetBo bo);

    /**
     * 修改过滤设置
     *
     * @param bo 过滤设置
     * @return 是否修改成功
     */
    Boolean updateByBo(FilterSetBo bo);

    /**
     * 校验并批量删除过滤设置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
